(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: VYRAZY.PAS                                                     *)
(*  Obsah: program na vyhodnocovani jednoduchych matematickych vyrazu      *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 24.8.2010                                             *)
(*  Pro kompilaci: nic                                                     *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program vyrazy;
{Program slouzi k vypoctum ciselnych (realnych) hodnot vyrazu zadanych jako
text, napr. '2+3*(4-1)/3.14'. Rozlisuje prioritu operatoru a umi zavorkovat.
Pri pripadne syntakticke chybe vypise na obrazovku chybove hlaseni a skonci.}

procedure chyba(hlaska:string);
{pomocna procedura na vypsani chyboveho hlaseni a ukonceni programu}
Begin
writeln('chyba: ',hlaska,'.');
writeln('Stiskni Enter...');
readln;
halt;
End;{chyba}

function priorita(ceho:char):byte; {rekne, jakou ma dane znamenko prioritu}
Begin
case ceho of '+','-':priorita:=10;   {na presnych hodnotach nezalezi,}
             '*','/':priorita:=20;   {jde jenom o to, ktera je vetsi }
             else chyba('neznamy operator');
             end;
End;{priorita}

function operace(PrvniOperand,DruhyOperand:real; operator:char):real;
{provede s danymi hodnotami danou operaci a vrati jeji vysledek}
Begin
case operator of '+':operace:=prvnioperand+druhyoperand;
                 '-':operace:=prvnioperand-druhyoperand;
                 '*':operace:=prvnioperand*druhyoperand;
                 '/':if druhyoperand=0 then chyba('deleni nulou')
                                       else operace:=prvnioperand/druhyoperand;
                 else chyba('neznamy operator "'+operator+'"');
                 end;
End;{operace}


{pomocne konstanty a promenne:}

const cifry=['0'..'9','.']; {z ceho se mohou skladat cisla}

var JednoCislo:string[20]; {pro tahani vicecifernych cisel z vyrazu}
    cislo:real; {pro prevod nalezenych cisel na binarni tvar}
    kod:integer; {pro kontrolu uspesnosti prevodu}
{tyto promenne jsou definovany vne funkce SpocitejVyraz proto, aby se setrilo
mistem v systemovem zasobniku pri pripadnem rekurzivnim volani}


{hlavni vyhodnocovaci funkce:}

function SpocitejVyraz(vyraz:string):real;
var operandy:array[1..128] of real; {zasobnik na hodnoty}
    PocetOperandu:byte; {pocet hodnot v tomto zasobniku}
    operatory:array[1..127] of char; {zasobnik na znamenka}
    PocetOperatoru, {pocet znamenek v zasobniku}
    PocetZavorek, {pro hledani koncu zavorek}
    ZacatekPodvyrazu,KonecPodvyrazu:byte; {pozice prvniho a posledniho znaku vyrazu v zavorce}
    index:byte; {pro prochazeni vyrazu}
    OK:boolean; {pro detekci neznamych znaku}
Begin
if vyraz='' then chyba('vyraz je prazdny');
if vyraz[1]='-' then vyraz:='0'+vyraz {aby se nemuselo zavadet unarni minus...}
 else if vyraz[1]='+' then delete(vyraz,1,1); {...a plus}
pocetoperandu:=0; pocetoperatoru:=0; {zasobniky jsou na zacatku prazdne}
index:=1; {pojedeme od prvniho znaku vyrazu}
while index<=length(vyraz) do {projdeme zadany vyraz}
  begin
  ok:=false; {zatim jsme jeste nic nenacetli}
  {------------------cisla:------------------}
  if vyraz[index] in cifry
    then begin
         jednocislo:=vyraz[index];
         inc(index);
         while index<=length(vyraz) do
           begin {nacteme zbyle cifry cisla}
           if vyraz[index] in cifry then jednocislo:=jednocislo+vyraz[index]
                                    else break; {uz jsme za cislem}
           inc(index);
           end;
         val(jednocislo,cislo,kod); {prevedeme na skutecnou ciselnou hodnotu}
         if kod<>0 then chyba('chybne zadane cislo'); {prevod se nepovedl}
         {ulozime hodnotu na zasobnik:}
         inc(pocetoperandu);
         operandy[pocetoperandu]:=cislo;
         ok:=true; {v poradku, naslo se platne cislo}
         {ted jsme na prvnim znaku za cislem}
         end;
  {------------------znamenka:------------------}
  if (index<=length(vyraz))and(vyraz[index] in ['+','-','*','/'])
    then begin
         while (pocetoperatoru<>0)and(priorita(vyraz[index])<=priorita(operatory[pocetoperatoru])) do
           begin
           {prave nacteny operator ma mensi prioritu nez ten na zasobniku;
            pred jeho vlozenim je potreba vyhodnotit vsechny predchozi
            operatory na zasobniku, ktere maji vetsi prioritu:}
           if pocetoperandu<2 then chyba('nedostatek operandu');
           {s dvema vrchnimi hodnotami na zasobniku provedeme operaci podle
            operatoru na vrcholu druheho zasobniku:}
           operandy[pocetoperandu-1]:=operace(operandy[pocetoperandu-1],
                                              operandy[pocetoperandu],
                                              operatory[pocetoperatoru]);
           dec(pocetoperandu); {dve hodnoty jsme zpracovali a jedna vznikla, dohromady tedy jedna ubyla}
           dec(pocetoperatoru); {spotrebovali jsme jeden operator}
           end;
         {ulozime novy operator na zasobnik:}
         inc(pocetoperatoru);
         operatory[pocetoperatoru]:=vyraz[index];
         inc(index); {ve vyrazu se posuneme za tento operator}
         ok:=true; {v poradku, naslo se platne znamenko}
         end;
  {------------------zavorky:------------------}
  if (index<=length(vyraz))and(vyraz[index]='(')
    then begin
         {zjistime, kde tahle zavorka konci:}
         pocetzavorek:=1;
         zacatekpodvyrazu:=index+1;
          repeat
          inc(index);
          if index>length(vyraz) then chyba('neukoncena zavorka');
          if vyraz[index]='(' then inc(pocetzavorek) {vnorene zavorky}
           else if vyraz[index]=')' then dec(pocetzavorek);
          until pocetzavorek=0; {ke kazde '(' jsme nasli prislusnou ')'}
         konecpodvyrazu:=index-1;
         {na vyraz v zavorce rekurzivne zavolame vyhodnoceni:}
         cislo:=spocitejvyraz(copy(vyraz,zacatekpodvyrazu,konecpodvyrazu-zacatekpodvyrazu+1));
         {a vysledek vlozime na zasobnik hodnot:}
         inc(pocetoperandu);
         operandy[pocetoperandu]:=cislo;
         inc(index); {posuneme se za zavorku}
         {ted jsme na prvnim znaku za zavorkou}
         ok:=true; {v poradku, nasla se platna zavorka}
         end;
  if not ok {nenaslo se cislo, znamenko ani zavorka}
    then chyba('neznamy znak: "'+vyraz[index]+'"');
  {slo by to udelat i jinak, treba pouzit case nebo if... else if...,
   ale takhle se usetri par pruchodu cyklem}
  end;
{vyraz je vyrizeny, ted jeste vyridime to, co zustalo v zasobnicich:}
while pocetoperandu>1 do {postupujeme tak dlouho, dokud nezustane posledni hodnota}
  begin
  if pocetoperatoru=0 then chyba('nedostatek operatoru');
  operandy[pocetoperandu-1]:=operace(operandy[pocetoperandu-1],
                                     operandy[pocetoperandu],
                                     operatory[pocetoperatoru]);
  dec(pocetoperandu);
  dec(pocetoperatoru);
  end;
if pocetoperatoru<>0 then chyba('prebytek operatoru');
spocitejvyraz:=operandy[1]; {posledni hodnota v zasobniku je vysledek}
End;{spocitejvyraz}


var ZadanyVyraz:string;

BEGIN
writeln('============ Vyhodnocovac jednoduchych matematickych vyrazu =============');
writeln('                        (c) Mircosoft 2010');
writeln('Podporovany jsou realne ciselne hodnoty (na oddeleni desetin pouzivejte');
writeln('tecku, ne carku), scitani, odcitani, nasobeni, deleni a zavorky.');
 repeat
 writeln;
 writeln('Zadej vyraz k vypocitani (nebo Enter = konec): ');
 readln(zadanyvyraz);
 if zadanyvyraz='' then writeln('Nashledanou.')
                   else writeln('Vysledek je ',spocitejvyraz(zadanyvyraz):0:4);
 until zadanyvyraz='';
END.